SystemOrganization addCategory: #'OmniST-Core-Misc'!
SystemOrganization addCategory: #'OmniST-Core-Compiler'!
SystemOrganization addCategory: #'OmniST-Core-Reflection'!

!ProcessorScheduler methodsFor: '*OmniST-Core-Roar-Compatibility' stamp: 'StefanMarr 11/6/2011 14:46'!
thisProcess
	"Added for RVM compatibility already.
	 Just to make sure that I can switch easily."
	^ self activeProcess! !

EncoderForV3PlusClosures subclass: #EncoderForOmniProxyExperiment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Core-Compiler'!

!EncoderForOmniProxyExperiment methodsFor: 'bytecode generation' stamp: 'StefanMarr 11/5/2011 22:02'!
adjustParseStackForPushInstVar: parseStack
	"Need to make sure that there is enough room in the allocated context frame for the stuff we do in the preamble"
	(OProxyDomain classHasDomainField: class) ifTrue: [
		parseStack push: 3.
		parseStack pop: 3.
	].! !

!EncoderForOmniProxyExperiment methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/2/2011 00:43'!
bindTempOrReturnOld: name
	"Declare a temporary, if necessary; or reuse existing.
	 This is only used for my omni hackery."
	scopeTable at: name ifPresent:
		[:node| ^ node].
	^self reallyBind: name! !

!EncoderForOmniProxyExperiment methodsFor: 'bytecode generation' stamp: 'StefanMarr 11/5/2011 22:31'!
genPushInstVar: instVarIndex
	"See genPushInstVar: #instVarIndex"
	
	"Objects of omni-aware classes redirect their field accesses to the
	 domain object to have permissions checked and do the actual access"
	((OProxyDomain classHasDomainField: class) and: [(OProxyDomain domainIndexFromClass: class) ~= (instVarIndex + 1)])
		ifFalse: [ ^super genPushInstVar: instVarIndex ]
		ifTrue:  [
			| omniDomainIdx instVarIdxLiteral readFieldOfLiteral |
			"That is all a big mess: 0-based vs. 1-based"
			omniDomainIdx := (OProxyDomain domainIndexFromClass: class) - 1.
			instVarIdxLiteral := self encodeLiteral: (instVarIndex + 1).
			readFieldOfLiteral := self encodeLiteral: #readField:of:.
			
			"Not really sure we need the nil check here,
			 but be conservative for now.
			 TODO: recheck need for nil-check later"
			
			super genPushInstVar: omniDomainIdx.
			self genPushSpecialLiteral: nil.
			self genSend: -198 numArgs: 1. "-198 should be #=="
			self genBranchPopFalse: 2. "STEFAN: todo that is wrong, depends on whether the size of the instructions in between is fixed, should sum that first with size* calls"
			super genPushInstVar: instVarIndex.
			self genJump: 4. "STEFAN: same here, needs to calculate correct size"
			
			super genPushInstVar: omniDomainIdx.
			
			"need to push the instVarIndex as constant/literal, first argument"
			(self
				if: instVarIdxLiteral code 
				isSpecialLiteralForPush: [:specialLit|
					self genPushSpecialLiteral: specialLit])
				ifFalse: [
					instVarIdxLiteral reserve: self.
					self genPushLiteral: instVarIdxLiteral index].
			
			"now push self, as new receiver, as second argument"
			self genPushReceiver.
			
			readFieldOfLiteral reserve: self.
			self genSend: (readFieldOfLiteral index) numArgs: 2.
			^ self
		]! !

!EncoderForOmniProxyExperiment methodsFor: 'bytecode generation' stamp: 'StefanMarr 11/5/2011 22:30'!
genStoreInstVar: instVarIndex
	"See super class implementation for actual details,
	 here we just add the delegation to the omni domain object"
	
	"Objects of omni-aware classes redirect their field accesses to the
	 domain object to have permissions checked and do the actual access"
	((OProxyDomain classHasDomainField: class) and: [(OProxyDomain domainIndexFromClass: class) ~= (instVarIndex + 1)])
		ifFalse: [ ^super genStoreInstVar: instVarIndex ]
		ifTrue:  [
			^ self genStoreInstVarCommon: instVarIndex doPop: false.
		]! !

!EncoderForOmniProxyExperiment methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/2/2011 18:57'!
genStoreInstVarCommon: instVarIndex doPop: pop
	"This is the common part for the store inst generation,
	 the test whether to generate it is done before hand"
	
	| omniDomainIdx instVarIdxLiteral writeFieldOfLiteral omniTmpVal |
	"That is all a big mess: 0-based vs. 1-based"
	omniDomainIdx := (class instVarIndexFor: #omniDomain) - 1.
	instVarIdxLiteral := self encodeLiteral: (instVarIndex + 1).
	writeFieldOfLiteral := self encodeLiteral: #write:toField:of:.
	
	omniTmpVal  := self bindTempOrReturnOld: 'omniTmpVal'.
	
	self genStorePopTemp: omniTmpVal index.
	
	super genPushInstVar: omniDomainIdx.
	self genPushSpecialLiteral: nil.
	self genSend: -198 numArgs: 1. "-198 should be #=="
	self genBranchPopFalse: 4. "STEFAN: todo that is wrong, depends on whether the size of the instructions in between is fixed, should sum that first with size* calls"

	self genPushTemp: omniTmpVal index.
	
	"pop ifTrue:  [super genStorePopInstVar: instVarIndex]
	    ifFalse: [super genStoreInstVar:    instVarIndex]."
	super genStoreInstVar: instVarIndex.
	
	self genJump: 6. "STEFAN: same here, needs to calculate correct size"
	
	super genPushInstVar: omniDomainIdx.
	self genPushTemp: omniTmpVal index.
	
	
	"need to push the instVarIndex as constant/literal, first argument"
	(self
		if: instVarIdxLiteral code 
		  isSpecialLiteralForPush: [:specialLit|
		  self genPushSpecialLiteral: specialLit])
		ifFalse: [
		  instVarIdxLiteral reserve: self.
		  self genPushLiteral: instVarIdxLiteral index].
			
	"now push self, as new receiver, as second argument"
	self genPushReceiver.
			
	writeFieldOfLiteral reserve: self.
	self genSend: (writeFieldOfLiteral index) numArgs: 3.
	
	"Different from the simple load in the pushInstVar stuff,
	 we need to pop the result of the omni-related send, which is not going to be used"
	pop ifTrue: [	self genPop.].
	^ self! !

!EncoderForOmniProxyExperiment methodsFor: 'bytecode generation' stamp: 'StefanMarr 11/5/2011 22:30'!
genStorePopInstVar: instVarIndex
	"See super class implementation for actual details,
	 here we just add the delegation to the omni domain object"
	
	"Objects of omni-aware classes redirect their field accesses to the
	 domain object to have permissions checked and do the actual access"
	((OProxyDomain classHasDomainField: class) and: [(OProxyDomain domainIndexFromClass: class) ~= (instVarIndex + 1)])
		ifFalse: [ ^super genStorePopInstVar: instVarIndex ]
		ifTrue:  [
			^ self genStoreInstVarCommon: instVarIndex doPop: true.
		]! !

Parser subclass: #ParserForOmniProxyExperiment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Core-Compiler'!

!ParserForOmniProxyExperiment class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/6/2011 00:24'!
encoderClassFor: aCompiledMethod
	^ (OProxyDomain classHasDomainField: aCompiledMethod methodClass)
			ifTrue:  [EncoderForOmniProxyExperiment]
			ifFalse: [super encoderClassFor: aCompiledMethod]! !

!ParserForOmniProxyExperiment methodsFor: 'public access' stamp: 'StefanMarr 11/2/2011 19:30'!
encoder
	^encoder ifNil:
		[encoder := EncoderForOmniProxyExperiment new]! !

!ParserForOmniProxyExperiment methodsFor: 'public access' stamp: 'StefanMarr 11/5/2011 22:14'!
temporaries
	| omniTemp temps |
	
	"Reserve a temporary variable for all omni-related store handling"
	(OProxyDomain classHasDomainField: encoder classEncoding) ifTrue: [
		omniTemp := encoder bindTempOrReturnOld: 'omniTmpVal'.
	].
	
	temps := super temporaries.
	
	omniTemp ifNotNil: [
		temps size = 0 ifTrue: [
			temps := OrderedCollection new.
		].
		temps addFirst: omniTemp
	].
	
	^ temps
	! !

Process subclass: #OProcess
	instanceVariableNames: 'omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Core-Misc'!

!OProcess methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/6/2011 14:48'!
omniDomain
	^ omniDomain! !

!OProcess methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/4/2011 01:59'!
omniDomain: aDomain
	omniDomain := aDomain! !

Object subclass: #OPromise
	instanceVariableNames: 'signal value'
	classVariableNames: 'NoValueDelivered'
	poolDictionaries: ''
	category: 'OmniST-Core-Misc'!

!OPromise class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/6/2011 00:19'!
example
	"This is not a real test case, but just to see how it is supposed to work"
	| p |
	p := OPromise new.
	
	[|val| 
	 Transcript log: 'About to read promised value.'.
	 val := p read.
	 Transcript log: 'Val: ', val asString.] fork.

	Processor yield.
	
	Transcript log: 'About to deliver promised value.'.
	p deliver: 42.
	Transcript log: 'Deliver promised value.'.
	! !

!OPromise class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/4/2011 15:53'!
initialize
	NoValueDelivered := Object new.! !

!OPromise methodsFor: 'announcing' stamp: 'StefanMarr 11/4/2011 16:07'!
deliver: aValue
	"Deliver the promised value."
	
	
	"Warning: this is racy, but we don't care for the moment.
	 Should be a single produce anyway. Everything else is a bug.
	 And, we do at least best effort error notification..."
	value = NoValueDelivered ifFalse: [
		| err |
		err := Error new.
		err messageText: 'Promise has been delivered more than once.'.
		err signal.
	].

	value := aValue.
	
	signal signal.
	
	^ value.! !

!OPromise methodsFor: 'initialization' stamp: 'StefanMarr 11/4/2011 16:09'!
initialize
	value := NoValueDelivered.
	signal := Semaphore new.! !

!OPromise methodsFor: 'accessing' stamp: 'StefanMarr 11/4/2011 16:01'!
read
	[value = NoValueDelivered] whileTrue: [
		"This is ugly, but I do not see how I can prevent the data
		 race for signals otherwise.
		 In case there are multiple possible consumers everyone
		 but the first will starve when they arrive before the
		 promise was delivered.
		 Now, we just have a delay, but it is guaranteed to return."
		signal waitTimeoutMSecs: 100.
	].
	^ value! !

Object subclass: #OProxyDomain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Core-Reflection'!

!OProxyDomain commentStamp: 'StefanMarr 11/4/2011 16:55' prior: 0!
OProxyDomain is the baseclass for all experiments that are done on the pure Smalltalk-level, without modifying the VM.

This class does intentionally not inherit from ODomain!!!

!OProxyDomain class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/6/2011 15:23'!
classHasDomainField: cls
	^ 0 ~= (self domainIndexFromClass: cls)! !

!OProxyDomain class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/6/2011 22:55'!
currentDomain
	^ self omniDomainFrom: Processor thisProcess! !

!OProxyDomain class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/5/2011 22:04'!
domainIndexFromClass: cls
	^ cls instVarIndexFor: #omniDomain! !

!OProxyDomain class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/5/2011 22:04'!
domainIndexFromObject: obj
	^ self domainIndexFromClass: obj class! !

!OProxyDomain class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/6/2011 21:06'!
initializeDomainForNewObject: obj of: class
	(self classHasDomainField: class) ifTrue: [
		| proc |
		proc := Processor thisProcess.
		(proc isKindOf: OProcess) ifTrue: [
			| domain |
			domain := self omniDomainFrom: proc.
			self setOmniDomainOn: obj of: class to: domain domainForNewObjects.
		].
	].! !

!OProxyDomain class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/5/2011 21:27'!
objectHasDomainField: obj
	^ self classHasDomainField: obj class! !

!OProxyDomain class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/6/2011 20:27'!
omniDomainFrom: obj
	| idx |
	idx := self domainIndexFromObject: obj.
	
	idx ~= 0 ifTrue: [
		^ obj instVarAt: idx.
	].

	^ nil! !

!OProxyDomain class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/6/2011 14:51'!
setOmniDomainOn: obj of: cls to: aDomain
	| idx |
	idx := self domainIndexFromClass: cls.
	obj instVarAt: idx put: aDomain.! !

!OProxyDomain methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/7/2011 18:08'!
adoptObject: obj
	self class setOmniDomainOn: obj of: obj class to: self! !

!OProxyDomain methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/6/2011 21:05'!
domainForNewObjects
	"#basicNew need to determine which domain a new object is supposed
	 to belong to.
	 The standard domain is self, the domain of the currently executing
	 OProcess.
	
	 If this method is overriden, make sure that you do not allocate any objects here!!!!!!"
	^ self! !

!OProxyDomain methodsFor: 'omni-domain' stamp: 'StefanMarr 11/4/2011 02:13'!
newProcessFor: aBlock
	"Answer a Process running the code in aBlock in this domain.
	 The process is not scheduled."
	| ctx proc |
	<primitive: 19> "Simulation guard"
	ctx := [aBlock value.
			Processor terminateActive] asContext.
	proc := OProcess
		forContext: ctx
		priority: Processor activePriority.
	proc omniDomain: self.
	^ proc.! !

!OProxyDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 10/31/2011 19:16'!
readField: idx of: obj
	Transcript cr; show: 'readField: ', idx asString, ' of: ', obj asString.
	^ obj instVarAt: idx! !

!OProxyDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 11/5/2011 03:13'!
requestExecutionOf: aCompiledMethod on: anObj with: arguments
	"Need to extract the arguments here"
	Transcript cr.
	Transcript show: 'requestExecutionOf: ', aCompiledMethod selector asString, ' on: ', anObj asString.
	Transcript cr; show: 'numArgs: ', arguments size asString.
	Transcript cr; show: 'arguments: ', arguments asString.
! !

!OProxyDomain methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/4/2011 16:59'!
spawnHere: aBlock
	"Spawn the given block as a process in this domain"
	
	self flag: 'WARNING: copied from ODomain.
	TODO: fix later after abstracting concepts from the results of the experiments.'.
	
	^ (self newProcessFor: aBlock) resume! !

!OProxyDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 11/4/2011 01:15'!
write: val toField: idx of: obj
	Transcript cr; show: 'write: ', val asString, ' toField: ', idx asString, ' of: ', obj asString.
	^ obj! !

Object subclass: #OProxyMethodWrapper
	instanceVariableNames: 'reference omniDomainIdx wrappedMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Core-Reflection'!

!OProxyMethodWrapper class methodsFor: 'initialization' stamp: 'StefanMarr 11/5/2011 00:33'!
initialize
	self registerForMethodChangeEvents! !

!OProxyMethodWrapper class methodsFor: 'instance creation' stamp: 'StefanMarr 11/4/2011 21:51'!
installOn: aClass selector: aSel
	^(self on: aClass selector: aSel) install;yourself! !

!OProxyMethodWrapper class methodsFor: 'instance creation' stamp: 'StefanMarr 11/4/2011 21:51'!
installOnClass: aClass
	|someWrappers|
	someWrappers:=OrderedCollection new.
	aClass selectors do: [:aSymbol | someWrappers add: (self installOn: aClass selector: aSymbol)].
	aClass class selectors do: [:aSymbol | someWrappers add: (self installOn: aClass class selector: aSymbol)].
	^someWrappers! !

!OProxyMethodWrapper class methodsFor: 'instance creation' stamp: 'StefanMarr 11/4/2011 21:51'!
installOnClassCategory: aString
	|someWrappers|
	someWrappers:= OrderedCollection new.
	(Smalltalk organization listAtCategoryNamed: aString) do: [:aClassName | 
		someWrappers addAll: (self installOnClass: (Smalltalk classNamed: aClassName)).
		].
	^someWrappers
	! !

!OProxyMethodWrapper class methodsFor: 'automated registration' stamp: 'StefanMarr 11/5/2011 22:29'!
methodWasChangedCheckAndPossiblyInstallMethodWrapper: event

	event itemKind = #method ifTrue: [
		(OProxyDomain classHasDomainField: event itemClass) ifTrue: [
			(self isKindOf: OProxyMethodWrapper) ifFalse: [
				"We want to make sure that every method is
				 actually encapsulated/wrapped with our wrapper"
				OProxyMethodWrapper
					installOn: event itemClass
					selector: event itemMethod selector.
			].
		].
	].! !

!OProxyMethodWrapper class methodsFor: 'instance creation' stamp: 'StefanMarr 11/4/2011 21:51'!
on: aMethodReference
	^self new initializeFor: aMethodReference ! !

!OProxyMethodWrapper class methodsFor: 'instance creation' stamp: 'StefanMarr 11/4/2011 21:51'!
on: aClass selector: aSelector
	^self on: (MethodReference class: aClass selector: aSelector)! !

!OProxyMethodWrapper class methodsFor: 'automated registration' stamp: 'StefanMarr 11/4/2011 23:42'!
registerForMethodChangeEvents
	SystemChangeNotifier uniqueInstance
		notify: self ofSystemChangesOfItem: #method change: #Added using: #methodWasChangedCheckAndPossiblyInstallMethodWrapper:;
		notify: self ofSystemChangesOfItem: #method change: #Modified using: #methodWasChangedCheckAndPossiblyInstallMethodWrapper:.! !

!OProxyMethodWrapper class methodsFor: 'instance creation' stamp: 'StefanMarr 11/4/2011 21:51'!
uninstallClass: aClass
	aClass methodDict values do: [:e | (e isKindOf: self) ifTrue: [e uninstall]].
	aClass class methodDict values do: [:e | (e isKindOf: self) ifTrue: [e uninstall]].! !

!OProxyMethodWrapper class methodsFor: 'instance creation' stamp: 'StefanMarr 11/4/2011 21:51'!
uninstallClassCategory: aString
	(Smalltalk organization listAtCategoryNamed: aString) do: [:aClassName | 
		self uninstallClass: (Smalltalk classNamed: aClassName)]! !

!OProxyMethodWrapper class methodsFor: 'instance creation' stamp: 'StefanMarr 11/4/2011 21:51'!
uninstallOnClassCategory: aString
	(Smalltalk organization listAtCategoryNamed: aString) do: [:aClassName | 
		self uninstallClass: (Smalltalk classNamed: aClassName)]! !

!OProxyMethodWrapper class methodsFor: 'automated registration' stamp: 'StefanMarr 11/5/2011 03:25'!
unregisterForChangeEvents
	SystemChangeNotifier uniqueInstance noMoreNotificationsFor: self.! !

!OProxyMethodWrapper methodsFor: 'testing' stamp: 'StefanMarr 11/5/2011 18:21'!
doesNotUnderstand: aMessage
	^ wrappedMethod isNil
		ifTrue: [super doesNotUnderstand: aMessage]
		ifFalse: [wrappedMethod perform: aMessage selector withArguments: aMessage arguments]! !

!OProxyMethodWrapper methodsFor: 'action' stamp: 'StefanMarr 11/4/2011 21:51'!
flushCache
	self selector flushCache ! !

!OProxyMethodWrapper methodsFor: 'initializing' stamp: 'StefanMarr 11/4/2011 21:51'!
initializeFor: aMethodReference 
	reference := aMethodReference.! !

!OProxyMethodWrapper methodsFor: 'action' stamp: 'StefanMarr 11/5/2011 22:06'!
install
	[wrappedMethod := self wrappedClass lookupSelector: self selector.
	wrappedMethod isKindOf: self class] whileTrue: [wrappedMethod uninstall].

	(OProxyDomain classHasDomainField: self wrappedClass)
		ifTrue: [
			omniDomainIdx := OProxyDomain domainIndexFromClass: self wrappedClass.
		]
		ifFalse: [ | err |
			err := Error new; 
							messageText: 'This method wrapper should only be used ',
							'for omni-related classes, which requires an omniDomain slot.'.
			err signal. ].

	"self wrappedClass addSelector: self selector withMethod: self" 
	self wrappedClass methodDict at: self selector put: self.
	
! !

!OProxyMethodWrapper methodsFor: 'accessing' stamp: 'StefanMarr 11/4/2011 21:51'!
reference
	^ reference ! !

!OProxyMethodWrapper methodsFor: 'action' stamp: 'StefanMarr 11/5/2011 18:19'!
run: aSelector with: arguments in: aReceiver
	| omniDomainOfReceiver |
	
	"We do the usual thing:
	  1. figure out whether the omniDomain is set properly.
	  2. if so, delegate and return
	     otherwise, execute in place"
	
	omniDomainOfReceiver := aReceiver instVarAt: omniDomainIdx.
	
	omniDomainOfReceiver
		ifNil:    [^ wrappedMethod valueWithReceiver: aReceiver arguments: arguments.]
		ifNotNil: [^ omniDomainOfReceiver requestExecutionOf: wrappedMethod on: aReceiver with: arguments].! !

!OProxyMethodWrapper methodsFor: 'accessing' stamp: 'StefanMarr 11/4/2011 21:51'!
selector
	"Answer the value of selector"

	^ reference selector! !

!OProxyMethodWrapper methodsFor: 'action' stamp: 'StefanMarr 11/5/2011 18:25'!
uninstall

	wrappedMethod isNil ifTrue: [^self].
	"self wrappedClass removeSelectorSilently: self selector.
	self wrappedClass addSelector: self selector withMethod: wrappedMethod.
	"
	self wrappedClass methodDict at: self selector put: wrappedMethod  

! !

!OProxyMethodWrapper methodsFor: 'accessing' stamp: 'StefanMarr 11/4/2011 21:51'!
wrappedClass
	"Answer the value of wrappedClass"

	^ reference actualClass! !

!OProxyMethodWrapper methodsFor: 'accessing' stamp: 'StefanMarr 11/5/2011 18:19'!
wrappedMethod
	"Answer the value of wrappedMethod"

	^ wrappedMethod! !

!OProxyMethodWrapper methodsFor: 'accessing' stamp: 'StefanMarr 11/5/2011 18:19'!
wrappedMethod: anObject
	"Set the value of wrappedMethod"

	wrappedMethod := anObject! !
OProxyMethodWrapper initialize!
OPromise initialize!
